/**
   @file

   Part of libcomm: contains block_random()
*/

#include <stdio.h>
#include <stdlib.h>


/**
   Get random numbers/bytes. This function read random numbers/bytes
   from /dev/urandom and stort this bytes in a buffer.

   @param buf (char *) in which the bytes will be stored. If this
   parameter is equal to NULL dynamic memory will be allocated.

   @param size an integer, specifies ths size of the buffer (the
   number of the random bytes). WARNING: If buf is not equal to null,
   n*(size) bytes will be stored in this buffer without any check of
   ths size of this buf.

   @return (char *) a pointer to the buffer in which the random bytes
   are stored.
*/
char *block_random(char *buf, int size) {
  FILE *f;

  // If no momory allocated, allocate memory
  if (buf == NULL) {
    if ((buf = malloc(size)) == NULL) {
      perror("malloc");
      return NULL;
    }
  }

  // Read Random numbers from /dev/urandom and stroe this these in the
  // buffer

  if ((f = fopen("/dev/urandom", "ro")) == NULL) {
    perror("fopen(/dev/urandom)");
    return NULL;
  }

  fread(buf, 1, size, f);

  fclose(f);

  return buf;
}
